<template>
  <el-autocomplete
    ref="wrapped"
    :value="value"
    :fetchSuggestions="filter"
    :placeholder="placeholder"
    @select="select"
    @focus="$emit('focus', $event)"
    @blur="$emit('blur', $event)"
  />
</template>

<script>
  export default {
    name: 'app-autocomplete',
    model: {
      prop: 'value',
      event: 'select'
    },
    props: {
      collection: {required: true, type: Array},
      placeholder: {required: false, default: '', type: String},
      value: {required: false, default: '', type: String}
    },
    computed: {
      suggestions() {
        return this.collection.map(
          item => ({value: item, link: item})
        )
      }
    },
    methods: {
      select({value, link}) {
        this.$emit('select', value)
      },
      filter(filterQuery, next) {
        next(this.suggestions.filter(suggestion =>
          (suggestion.value.toLowerCase().indexOf(filterQuery.toLowerCase()) === 0)
        ))
      }
    }
  }
</script>

<style lang="scss">
  .el-col {
    .el-autocomplete {
      display:block
    }
  }
</style>
